/*
 * Promemoria.h
 *
 *  Created on: 13/mag/2013
 *      Author: bertini
 */

#ifndef PROMEMORIA_H_
#define PROMEMORIA_H_

#include <string>
#include <iostream> // per funzione friend operator<<
// Chiave
class Data {
public:
	Data() :
			anno(2013), mese(1), giorno(1) {
	}
	// in alternativa all'uso del functor di comparazione basta definire l'operatore <
	bool operator<(const Data& right) const {
		if (anno > right.anno)
			return false;
		else if (anno == right.anno) {
			if (mese > right.mese)
				return false;
			else if (mese == right.mese) {
				if (giorno > right.giorno)
					return false;
				else if (giorno == right.giorno)
					return false;
				else
					return true;
			} else
				return true;
		} else
			return true;
	}
	bool operator==(const Data& right) const {
		if (anno != right.anno)
			return false;
		if (mese != right.mese)
			return false;
		if (giorno != right.giorno)
			return false;
		return true;
	}
	friend std::ostream& operator<<(std::ostream &os, const Data& stampa);
	int anno, mese, giorno;
};

// funzione friend per stampare la Data
std::ostream& operator<<(std::ostream &os, const Data& stampa) {
	return os << stampa.anno << "/" << stampa.mese << "/" << stampa.giorno;
}

// Functor per comparare date - da usare in mappe in cui la chiave e' la classe Data
class DataComparator {
public:
	// rende true se la data first deve andare prima della data second
	bool operator()(const Data& first, const Data& second) const {
		if (first.anno > second.anno)
			return false;
		else if (first.anno == second.anno) {
			if (first.mese > second.mese)
				return false;
			else if (first.mese == second.mese) {
				if (first.giorno > second.giorno)
					return false;
				else if (first.giorno == second.giorno)
					return false;
				else
					return true;
			} else
				return true;
		} else
			return true;
	}
};

// Valore
class Promemoria {
public:
	Promemoria() :
			scadenza(), titolo(""), fatto(false) {
	}
	// operator== e' necessario per algoritmo find
	bool operator==(const Promemoria& right) const {
		if (!(scadenza == right.scadenza))
			return false;
		if (titolo != right.titolo)
			return false;
		if (fatto != right.fatto)
			return false;
		return true;
	}

	Data scadenza;
	std::string titolo;
	bool fatto;
};

#endif /* PROMEMORIA_H_ */
